// thread5.cpp
// Glenn G. Chappell
// 6 Feb 2013
//
// For CS 321 Spring 2013
// Use of mutex - non-blocking

#include <iostream>
using std::cout;
using std::endl;
#include <thread>
using std::thread;
#include <mutex>
using std::mutex;


int count;         // Counter; we want to limit this to 3
mutex count_lock;  // Mentally associate this with variable count


// Run function for spawned threads
// Increment global count if it is less than 3.
// Non-blocking use of global mutex count_lock prevents
//  some errors, but not all.
void run(int n)
{
    bool gotlock = count_lock.try_lock();
    if (gotlock)
    {  // We have the lock
        if (count < 3)
        {
            cout << "count is low; incrementing" << endl;
            ++count;
            count_lock.unlock();
        }
        else
        {
            count_lock.unlock();
            cout << "count is high; NOT incrementing" << endl;
        }
    }
    else
    {  // We do NOT have the lock
        cout << "Could not get lock" << endl;
        // We now give up. If too many threads give up,
        //  then count will never get to 3.
    }
}


int main()
{
    count = 0;
    cout << "Master: start count = " << count << endl;

    thread t1(run, 1);
    thread t2(run, 2);
    thread t3(run, 3);
    thread t4(run, 4);
    thread t5(run, 5);

    t1.join();
    t2.join();
    t3.join();
    t4.join();
    t5.join();

    cout << "Master: end count = " << count << endl;
    cout << "Master: (We want the above to be " << 3 << ")" << endl;

    return 0;
}

